﻿

Public Class PersonaCuatro
    Implements IEqualityComparer

    Private _nombre As String
    Private _dni As String

    Public Property Nombre() As String
        Get
            Return _nombre
        End Get
        Set(ByVal value As String)
            _nombre = value
        End Set
    End Property

    Public Property DNI() As String
        Get
            Return _dni
        End Get
        Set(ByVal value As String)
            _dni = value
        End Set
    End Property


    Public Sub New(ByVal nombre As String, ByVal dni As String)
        Me._nombre = nombre
        Me._dni = dni
    End Sub


    Public Overloads Overrides Function GetHashCode() As Integer
        Return _dni.GetHashCode()
    End Function

    Public Overloads Overrides Function Equals(ByVal obj As Object) As Boolean
        '----------------------------------------------
        ' Explicacion de la linea Return
        ' Dim unapersona As Persona
        ' unapersona = CType(obj, Persona)
        ' Return unapersona.DNI.Equals(_dni)
        '----------------------------------------------
        Return (CType(obj, PersonaCuatro)).DNI.Equals(_dni)
    End Function


    'Public Overloads Function Equals(ByVal other As PersonaDos) As Boolean _
    '       Implements System.IEquatable(Of PersonaDos).Equals
    '    Return other.DNI.Equals(_dni)
    'End Function

    Public Overloads Function Equals(ByVal x As Object, ByVal y As Object) As Boolean _
          Implements System.Collections.IEqualityComparer.Equals
        Return (CType(x, PersonaCuatro)).DNI.Equals((CType(y, PersonaCuatro)).DNI)
    End Function

    Public Overloads Function GetHashCode(ByVal obj As Object) As Integer _
           Implements System.Collections.IEqualityComparer.GetHashCode
        Return Me.GetHashCode()
    End Function
End Class
